import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;


import com.java4less.vision.RImage;
import com.java4less.vision.datamatrix.DatamatrixData;
import com.java4less.vision.datamatrix.DatamatrixReader;



public class DatamatrixSample {
	
	private String[] testSet={"dm.png","dm2.png","dm3.png","dm4.png","dm5.png","dm6.png","d1.png","d2.png","d3.png","d4.png","d5.png","i7.png","i6.png"};
	//private String[] testSet={"test.png"  } ; //"i3.png"}; //d1.png","d2.png","d3.png","d4.png","d5.png"}; //"dm.png","dm2.png","dm3.png","dm4.png","dm5.png","dm6.png"};
	
	private String dir="images\\";
	
	public static void main(String[] args)  {
	
		DatamatrixSample sample=new DatamatrixSample();
		try {
			
			
			sample.runTests();
		} catch (Exception e) {

			e.printStackTrace();
		}
		System.exit(0);
		
	}
	
	/**
	 * read all test files
	 *
	 */
	public void runTests() {		
		for (int i=0;i<testSet.length;i++) {
			try {
				
				System.out.println("");
				System.out.println("------------------------------");
				System.out.println("Scanning File: "+testSet[i]);
				System.out.println("");
				scanImage(testSet[i]);
				System.out.println("------------------------------");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}		
	}
	
	/**
	 * scan file
	 * @param file image file

	 * @throws Exception
	 */
	public void scanImage(String file) throws Exception {
		
		Image im=loadImage(dir+file);
		
		DatamatrixReader reader=new DatamatrixReader();
		
		long prv=System.currentTimeMillis();
		
		RImage rim=new RImage((BufferedImage) im);

        long tim=System.currentTimeMillis();
        DatamatrixData[] barcodes=reader.read(rim);
		rim=null;
		im=null;
		
		System.out.print("End. "+(System.currentTimeMillis()-tim)+". ");
		if (barcodes.length==0) System.out.println("*** NO BARCODE FOUND ***");
		
		for (int i=0;i<barcodes.length;i++) {
			System.out.println("Barcode  found "+barcodes[i].toString());
			
		}
						
	}
	
	/**
	 * load image from file
	 * @param f
	 * @return
	 * @throws Exception
	 */
	public Image loadImage(String f) throws Exception {
			Image im2=null;
			java.awt.MediaTracker mt2=null;

			java.io.FileInputStream in=null;
			byte[] b=null;
			int size=0;


			in=new java.io.FileInputStream( f);
			if (in!=null) {
				size=in.available();
				b=new byte[size];
				in.read(b);
				im2=java.awt.Toolkit.getDefaultToolkit().createImage(b);
				in.close();
			}

			mt2 = new java.awt.MediaTracker(new Canvas());		
			if (im2!=null) {
				if (mt2!=null) {mt2.addImage(im2,0); mt2.waitForID(0);}
				int WidthIm = im2.getWidth(null);
			}


		BufferedImage input=new BufferedImage(im2.getWidth(null),im2.getHeight(null),BufferedImage.TYPE_INT_ARGB);
		
		Graphics g=input.createGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,im2.getWidth(null),im2.getHeight(null));
		g.drawImage(im2,0,0,null);
		g.dispose();
		g=null;
		
		return input;


		}	

}
